`timescale 1ns / 10ps

module npmos (
    input  DATA    , // data input
    input  CONTROL , // control input
    output OUTn    , // nmos out output
    output OUTp      // pmos out output
);

    nmos unmos ( OUTn, DATA, CONTROL );
    pmos upmos ( OUTp, DATA, CONTROL );

endmodule


module tb_npmos ;
reg  DATA , CONTROL ;
wire OUTn , OUTp    ;

parameter RATE = 100 ;

initial begin
  CONTROL = 1'b0 ; 
  DATA    = 1'b0 ;
  #(RATE) DATA = 1'b1 ;
  #(RATE) DATA = 1'bx ;
  #(RATE) DATA = 1'bz ;
  #(RATE) ;
  CONTROL = 1'b1 ;
  DATA    = 1'b0 ;
  #(RATE) DATA = 1'b1 ;
  #(RATE) DATA = 1'bx ;
  #(RATE) DATA = 1'bz ;
  #(RATE) ;
  CONTROL = 1'bx ;
  DATA    = 1'b0 ;
  #(RATE) DATA = 1'b1 ;
  #(RATE) DATA = 1'bx ;
  #(RATE) DATA = 1'bz ;
  #(RATE) ;
  CONTROL = 1'bz ;
  DATA    = 1'b0 ;
  #(RATE) DATA = 1'b1 ;
  #(RATE) DATA = 1'bx ;
  #(RATE) DATA = 1'bz ;
  #(RATE) ;
end

npmos unpmos (
    .DATA    (DATA   ),
    .CONTROL (CONTROL),
    .OUTn    (OUTn   ),
    .OUTp    (OUTp   )
);

endmodule
